'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}var _ReverseRoutingDataJs = require('./ReverseRoutingData.js');var _ReverseRoutingDataJs2 = _interopRequireDefault(_ReverseRoutingDataJs);var _PathNodeJs = require(
'./PathNode.js');var _PathNodeJs2 = _interopRequireDefault(_PathNodeJs);

/**
 * Router for usage by Page and react components. Doesn't support routing, just
 * reverse routing.
 *
 * @CLIENT-SERVER
 */var 
PageRouter = (function () {















  /**
   * @param {?Array<Node>} preProcessNodes
   * @param {?Array<Node>} postProcessNodes
   * @param {?{[key:string]: Array<Node>}} routeNodes
   */
  function PageRouter(preProcessNodes, postProcessNodes, routeNodes) {_classCallCheck(this, PageRouter);
    this._preProcessNodes = preProcessNodes == null ? [] : preProcessNodes;
    this._postProcessNodes = postProcessNodes == null ? [] : postProcessNodes;
    this._routeNodes = routeNodes == null ? {} : routeNodes;}


  /**
   * @returns {PageRouter}
   */_createClass(PageRouter, [{ key: 'createPageRouter', value: 
    function createPageRouter() {
      return this;} }, { key: 'validatePages', value: 


    function validatePages() {
      throw new Error('Calling validatePages() in page router is not allowed.');} }, { key: 'setLogger', value: 


    function setLogger() {
      throw new Error('Calling setLogger() in page router is not allowed.');} }, { key: 'set404NotFoundPage', value: 


    function set404NotFoundPage() {}
    // No-op. In client, we don't need to know the 404 not found page, since
    // we are not doing any routing in client side.


    /**
     * @param {string} routeId
     * @param {string} pageName
     * @param {?Array<Node>} startNodes
     * @param {Array<Node>} path
     * @param {?Array<Node>} endNodes
     */ }, { key: 'reg', value: 
    function reg(routeId, pageName, startNodes, path, endNodes) {
      // Since this class is only used for reverse routing, no need to do
      // further processing.
      var nodes = PageRouter.joinNodes(startNodes, path, endNodes);
      if (nodes.length < 1) {
        throw new Error('Invalid route, no nodes discovered: ' + routeId);}

      this._routeNodes[routeId] = nodes;}


    /**
     * @param {string} routeId
     * @param {?Object} routeArgs
     * @param {?string} fragment
     * @returns {string}
     */ }, { key: 'reverseRoute', value: 
    function reverseRoute(routeId, routeArgs, fragment) {
      return PageRouter.reverseRoute(routeId, routeArgs, fragment, this._routeNodes);} }, { key: 'route', value: 


    function route() {
      throw new Error('Method route() called in client router!');}


    /**
     * @param {?Array<Node>} startNodes
     * @param {string} path
     * @param {?Array<Node>} endNodes
     * @return {Array<Node>}
     */ }], [{ key: 'joinNodes', value: 
    function joinNodes(startNodes, path, endNodes) {
      if (!startNodes) startNodes = [];
      if (!endNodes) endNodes = [];
      var pathNodes = _PathNodeJs2['default'].createFromPath(path);
      var i, nodes = [];
      for (i = 0; i < startNodes.length; i++) nodes.push(startNodes[i]);
      for (i = 0; i < pathNodes.length; i++) nodes.push(pathNodes[i]);
      for (i = 0; i < endNodes.length; i++) nodes.push(endNodes[i]);
      return nodes;}


    /**
     * @param {string} routeId
     * @param {?Object} routeArgs
     * @param {?string} fragment
     * @param {Array<Node>} routeNodes
     * @returns {string}
     */ }, { key: 'reverseRoute', value: 
    function reverseRoute(routeId, routeArgs, fragment, routeNodes) {
      if (!routeNodes.hasOwnProperty(routeId)) {
        throw new Error('Reverse routing called for uknown route: \'' + routeId + '\'.');}

      var i, nodes = routeNodes[routeId];
      var reverseRoutingData = new _ReverseRoutingDataJs2['default'](routeArgs);
      for (i = 0; i < nodes.length; i++) {
        nodes[i].reverseEvaluate(reverseRoutingData);}

      return reverseRoutingData.toUrlString(fragment);} }]);return PageRouter;})();exports['default'] = PageRouter;module.exports = exports['default']; /**
                                                                                                                                                         * @type {Array<Node>}
                                                                                                                                                         */ /**
                                                                                                                                                             * @type {Array<Node>}
                                                                                                                                                             */ /**
                                                                                                                                                                 * @type {{[key: string]: Array<Node>}}
                                                                                                                                                                 */
//# sourceMappingURL=PageRouter.js.map